/*
 * WALTZ
 *
 * In the header file there are constants for DFPNS enhancements.
 *
 * Copyright  2012-2013 Pavel Vesely <vesely@kam.mff.cuni.cz>
 *
 * This program is distributed under the GNU General Public License.
 * See COPYING for details.
 */
#ifndef PNS_H_INCLUDED
#define PNS_H_INCLUDED

#include "ai/lib.h"
// array for hashing
#include "ai/hashedpositions.h"

#define INFINITY_PNS 2000000000u

#define TT2SIZE (1 << 20)
#define DFPNS_EPS 8
#define DFPNS_SEARCH_NODES 10000000	//for estimating search duration
// for eval based PNS
#define EFBPNS_T 1000000000
#define EFBPNS_A 3
#define EFBPNS_B 20
// weak PNS heuristic counting
#define WPNS_T 10000000
#define WPNS_H 1
// for dynamic widening
#define DWPNS_J 3

extern uns maxDfpnsSearchedNodes;

typedef struct tt2Entry {
	thash hash;
	u32 pn, dn;
	u32 minWinningDepth, maxLosingDepth;
	u32 searchedNodes;

} TT2Entry;

FullMove *dfpns(uns depth, uns tpn, uns tdn);
FullMove *dfpnsEpsTrick(uns depth, uns tpn, uns tdn);
FullMove *weakpns(uns depth, uns tpn, uns tdn);
FullMove *dfpnsEvalBased(uns depth, uns tpn, uns tdn);
FullMove *dfpnsWeakEpsEval(uns depth, uns tpn, uns tdn);
FullMove *dfpnsDynWideningEpsEval(uns depth, uns tpn, uns tdn);
TT2Entry *LookupPositionInTT2(void);

#endif				// PNS_H_INCLUDED
